"use strict";
exports.__esModule = true;
var domManagement_1 = require("./domManagement");
/**
 * Class containing a set of static utilities functions for precision date
 */
var PrecisionDate = /** @class */ (function () {
    function PrecisionDate() {
    }
    Object.defineProperty(PrecisionDate, "Now", {
        /**
         * Gets either window.performance.now() if supported or Date.now() else
         */
        get: function () {
            if (domManagement_1.DomManagement.IsWindowObjectExist() && window.performance && window.performance.now) {
                return window.performance.now();
            }
            return Date.now();
        },
        enumerable: true,
        configurable: true
    });
    return PrecisionDate;
}());
exports.PrecisionDate = PrecisionDate;
