"use strict";
exports.__esModule = true;
var effect_1 = require("../Materials/effect");
require("./ShadersInclude/bonesDeclaration");
require("./ShadersInclude/clipPlaneVertexDeclaration");
require("./ShadersInclude/instancesDeclaration");
require("./ShadersInclude/instancesVertex");
require("./ShadersInclude/bonesVertex");
require("./ShadersInclude/clipPlaneVertex");
var name = 'colorVertexShader';
var shader = "\nattribute vec3 position;\n#ifdef VERTEXCOLOR\nattribute vec4 color;\n#endif\n#include<bonesDeclaration>\n#include<clipPlaneVertexDeclaration>\n\n#include<instancesDeclaration>\nuniform mat4 viewProjection;\n#ifdef MULTIVIEW\nuniform mat4 viewProjectionR;\n#endif\n\n#ifdef VERTEXCOLOR\nvarying vec4 vColor;\n#endif\nvoid main(void) {\n#include<instancesVertex>\n#include<bonesVertex>\nvec4 worldPos=finalWorld*vec4(position,1.0);\n#ifdef MULTIVIEW\nif (gl_ViewID_OVR == 0u) {\ngl_Position=viewProjection*worldPos;\n} else {\ngl_Position=viewProjectionR*worldPos;\n}\n#else\ngl_Position=viewProjection*worldPos;\n#endif\n#include<clipPlaneVertex>\n#ifdef VERTEXCOLOR\n\nvColor=color;\n#endif\n}";
effect_1.Effect.ShadersStore[name] = shader;
/** @hidden */
exports.colorVertexShader = { name: name, shader: shader };
